# This file was created automatically by SWIG.
import piezoelectricityc
from oof2.SWIG.engine.properties import PropertyPtr
from oof2.SWIG.engine.symmmatrix import SymmMatrix3Ptr
from oof2.SWIG.engine.rank3tensor import Rank3TensorPtr
class IsotropicPiezoElectricityPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C IsotropicPiezoElectricity instance at %s>" % (self.this,)
class IsotropicPiezoElectricity(IsotropicPiezoElectricityPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(piezoelectricityc.new_IsotropicPiezoElectricity,_args,_kwargs)
        self.thisown = 1




class AnisotropicPiezoElectricityPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def dijk(self, *_args, **_kwargs):
        val = apply(piezoelectricityc.AnisotropicPiezoElectricity_dijk,(self,) + _args, _kwargs)
        if val: val = Rank3TensorPtr(val) ; val.thisown = 1
        return val
    def __repr__(self):
        return "<C AnisotropicPiezoElectricity instance at %s>" % (self.this,)
class AnisotropicPiezoElectricity(AnisotropicPiezoElectricityPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(piezoelectricityc.new_AnisotropicPiezoElectricity,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: piezoelectricity.spy,v $
# $Revision: 1.6 $
# $Author: langer $
# $Date: 2006-04-10 17:46:22 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 


from oof2.SWIG.engine import rank3tensor
from oof2.SWIG.engine import symmmatrix
from oof2.common import utils
from oof2.common.IO import parameter
from oof2.engine import problem
from oof2.engine import propertyregistration

PropertyRegistration = propertyregistration.PropertyRegistration

# The different types of piezoelectricity differ only in their dijk
# parameters, which are all subclasses of Rank3Tensor.  Each of the
# PropertyRegistrations can register AnisotropicPiezoElectricity
# directly.
        
######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Triclinic:C1',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",319,
    [rank3tensor.C1Rank3TensorParameter('dijk',
                                        rank3tensor.C1Rank3Tensor(d11 = 1, d12 = 1, d13 = 1, d14 = 1, d15 = 1, d16 = 1,
                                                                  d21 = 1, d22 = 1, d23 = 1, d24 = 1, d25 = 1, d26 = 1,
                                                                  d31 = 1, d32 = 1, d33 = 1, d34 = 1, d35 = 1, d36 = 1)
                                        ,
                                        tip="point group 1 piezoelectricity tensor")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='C1 piezoelectricity')

######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Monoclinic:C2',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",318,
    [rank3tensor.C2Rank3TensorParameter('dijk',
                                        rank3tensor.C2Rank3Tensor(d14 = 1, d16 = 1,
                                                                  d21 = 1, d22 = 1, d23 = 1, d25 = 1, 
                                                                  d34 = 1, d36 = 1) 
                                        ,
                                        tip="point group 2 (with a single two-fold axis) piezoelectricity tensor")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='C2 piezoelectricity')

######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Monoclinic:Cs',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",317,
    [rank3tensor.CsRank3TensorParameter('dijk',
                                        rank3tensor.CsRank3Tensor(d11 = 1, d12 = 1, d13 = 1, d15 = 1,
                                                                  d24 = 1, d26 = 1,
                                                                  d31 = 1, d32 = 1, d33 = 1, d35 = 1) 
                                        ,
                                        tip="point group m (with a single mirror plane) piezoelectricity tensor")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='Cs piezoelectricity')


######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Orthorhombic:D2',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",316,
    [rank3tensor.D2Rank3TensorParameter('dijk',
                                     rank3tensor.D2Rank3Tensor(d14=1.0, d25=1.0, d36=1.0),
                                     tip="222 piezoelectricity tensor")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='D2 piezoelectricity')

######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Orthorhombic:C2v',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",315,
    [rank3tensor.C2vRank3TensorParameter('dijk',
                                     rank3tensor.C2vRank3Tensor(d15 = 1, d24 = 1, d31 = 1, d32 = 1, d33 = 1),
                                     tip="mm2 piezoelectricity tensor")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='C2v piezoelectricity')

######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Tetragonal:C4',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",314,
    [rank3tensor.C4Rank3TensorParameter('dijk',
                                     rank3tensor.C4Rank3Tensor(d14 = 1, d15 = 1, d31 = 1, d33 = 1),
                                     tip="Point group 4 piezoelectricity tensor")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='C4 piezoelectricity')


######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Tetragonal:C4i',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",313,
    [rank3tensor.C4iRank3TensorParameter('dijk',
                                     rank3tensor.C4iRank3Tensor(d14 = 1, d15 = 1, d31 = 1, d36 = 1),
                                     tip="Also known as C4h and bar{4} piezoelectric tensor")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='C4i piezoelectricity')


######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Tetragonal:D4',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",312,
    [rank3tensor.D4Rank3TensorParameter('dijk',
                                     rank3tensor.D4Rank3Tensor(d14 = 1),
                                     tip="Also known as 422 piezoelectric tensor")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='C4i piezoelectricity')



######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Tetragonal:C4v',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",311,
    [rank3tensor.C4vRank3TensorParameter('dijk',
                                     rank3tensor.C4vRank3Tensor(d15=1.0, d31=1.0, d33=1.0),
                                     tip="4mm piezoelectricity tensor")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='C4v piezoelectricity')

######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Tetragonal:D2d',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",310,
    [rank3tensor.D2dRank3TensorParameter('dijk',
                                     rank3tensor.D2dRank3Tensor(d14 = 1, d36 = 1),
                                     tip="Also known as bar{4}2m piezoelectric tensor")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='D2d piezoelectricity')

######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Trigonal:C3',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",309,
    [rank3tensor.C3Rank3TensorParameter('dijk',
                                     rank3tensor.C3Rank3Tensor(d11 = 1, d14 = 1, d15 = 1, d22 = 1, d31 = 1, d33 = 1),
                                     tip="Also known as point group 3")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='C3 piezoelectricity')

######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Trigonal:D3',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",308,
    [rank3tensor.D3Rank3TensorParameter('dijk',
                                     rank3tensor.D3Rank3Tensor(d11 = 1, d14 = 1),
                                     tip="Also known as point group 32")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='D3 piezoelectricity')

######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Trigonal:C3v',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",307,
    [rank3tensor.C3vRank3TensorParameter('dijk',
                                     rank3tensor.C3vRank3Tensor(d15 = 1, d22 = 1, d31 = 1, d33 = 1),
                                     tip="Also known as point group 3m")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='C3v piezoelectricity')



######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Hexagonal:C6',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",306,
    [rank3tensor.C6Rank3TensorParameter('dijk',
                                     rank3tensor.C6Rank3Tensor(d14 = 1, d15=1.0, d31=1.0, d33=1.0),
                                     tip="Also known as class 6 point group")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='C6 piezoelectricity')


######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Hexagonal:D6i',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",305,
    [rank3tensor.D6iRank3TensorParameter('dijk',
                                     rank3tensor.D6iRank3Tensor(d11 = 1, d22 = 1),
                                     tip="Also known as point group bar{6}")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='D6i piezoelectricity')


######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Hexagonal:D6',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",304,
    [rank3tensor.D6Rank3TensorParameter('dijk',
                                     rank3tensor.D6Rank3Tensor(d14 = 1),
                                     tip="Also known as point group 622")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='D6 piezoelectricity')


######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Hexagonal:C6v',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",303,
    [rank3tensor.C6vRank3TensorParameter('dijk',
                                     rank3tensor.C6vRank3Tensor(d15=1.0, d31=1.0, d33=1.0),
                                     tip="6mm piezoelectricity tensor")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='C6v piezoelectricity')



######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Hexagonal:D3h',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",302,
    [rank3tensor.D3hRank3TensorParameter('dijk',
                                     rank3tensor.D3hRank3Tensor(d22 = 1),
                                     tip="Also known as point group bar{6}m2")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='D3h piezoelectricity')


######################################################

PropertyRegistration(
    'Couplings:PiezoElectricity:Cubic:Td',
    AnisotropicPiezoElectricity,
    "oof2.SWIG.engine.property.piezoelectricity.piezoelectricity",301,
    [rank3tensor.TdRank3TensorParameter('dijk',
                                     rank3tensor.TdRank3Tensor(d14 = 1),
                                     tip="Also known as point group 23, bar{4}3m, or simply T")],
    fields=[problem.Voltage, problem.Displacement],
    fluxes=[problem.Total_Polarization, problem.Stress],
    outputs=["Strain", "Energy"],
    propertyType="PiezoElectricity",
    tip='Td piezoelectricity')

