# -*- python -*-
# $RCSfile: automatic.py,v $
# $Revision: 1.9 $
# $Author: haan $
# $Date: 2006-05-12 04:52:03 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# Parameters can take the value 'automatic' to indicate that they
# should be set automatically.

from oof2.common import utils

class SpecialValue:
    def __cmp__(self, other):
        if isinstance(other, SpecialValue) and \
           self.__class__ == other.__class__:
            return 0
        return 1
    def __hash__(self):
        return hash(id(self.__class__))
    
class Automatic(SpecialValue):
    def __repr__(self):
        return 'automatic'

automatic = Automatic()

utils.OOFdefine('automatic', automatic)

# xml doc is loaded by automaticdoc.py to avoid an import loop.

##class Latest(SpecialValue):
##    def __repr__(self):
##        return 'latest'

##latest = Latest()

##utils.OOFdefine('latest', latest)
