/* -*- C++ -*-
 $RCSfile: canny.h,v $
 $Revision: 1.3 $
 $Author: olgak $
 $Date: 2007-07-20 14:17:55 $

 This software was produced by NIST, an agency of the U.S. government,
 and by statute is not subject to copyright in the United States.
 Recipients of this software assume all responsibilities associated
 with its operation, modification and maintenance. However, to
 facilitate maintenance we ask that before distributing modified
 versions of this software, you first contact the authors at
 oof_manager@ctcms.nist.gov. */ 

#include <oofconfig.h>
#include <stdio.h>
#include <math.h>
#include "common/doublearray.h"
#include "image/oofimage.h"

#ifndef CANNY_ALGORITHM_H
#define CANNY_ALGORITHM_H

/*
Uses the Canny algorithm in order to find the edges in an image. 
Is usually passed an image that has been blurred through a gaussian blur.  

*/


class CannyClass {
	private:
		ICoord size;
	public:
		void suppressMax(DoubleArray & final, DoubleArray angle, DoubleArray gradient);
		CannyClass(ICoord s);
		void findEdge(bool &edgeEnd, int colShift, int rowShift, ICoord center, int dir, double lowerThreshold, DoubleArray gradient, DoubleArray edgeDir, DoubleArray &final);
		void touchBorders(DoubleArray &final, double lowerThreshold);
		DoubleArray updateCannyArray(DoubleArray gray,  double lowerThreshold, double upperThreshold);
		bool pixelInBounds(ICoord pxl);
		
};

#endif
