/* -*- C++ -*-
 $RCSfile: classify.h,v $
 $Revision: 1.6 $
 $Author: olgak $
 $Date: 2007-07-20 14:17:55 $

 This software was produced by NIST, an agency of the U.S. government,
 and by statute is not subject to copyright in the United States.
 Recipients of this software assume all responsibilities associated
 with its operation, modification and maintenance. However, to
 facilitate maintenance we ask that before distributing modified
 versions of this software, you first contact the authors at
 oof_manager@ctcms.nist.gov. */ 
 
  
#include <oofconfig.h>
#include <stdio.h>
#include <math.h>
#include "common/doublearray.h"
#include "image/oofimage.h"

#ifndef CLASSIFYING_H
#define CLASSIFYING_H

/*
Classifies the image by intensity. Groups together touching like colors. Changes each neighboring color to a different color, so that is easier seen.

Behaves strangely when used after the Canny Algorithm. (probobly because of overflow when one region is too large).

*/


class ClassifyClass {
	private:
		bool pixelInBounds(ICoord px1, ICoord size);
	public:
		ClassifyClass();
		DoubleArray classifyRegions(DoubleArray changed);
		void changeNeighbors(ICoord coord, DoubleArray &changed, double curr, double changeTo, DoubleArray &classified, int maxi, int maxj, DoubleArray old_changed);
		void fixWrongBorders(DoubleArray & changed, DoubleArray original);

		

};

#endif


