/* -*- C++ -*-
 $RCSfile: fixborders.h,v $
 $Revision: 1.4 $
 $Author: olgak $
 $Date: 2007-07-20 17:50:57 $

 This software was produced by NIST, an agency of the U.S. government,
 and by statute is not subject to copyright in the United States.
 Recipients of this software assume all responsibilities associated
 with its operation, modification and maintenance. However, to
 facilitate maintenance we ask that before distributing modified
 versions of this software, you first contact the authors at
 oof_manager@ctcms.nist.gov. */ 
 
 
#include "common/doublearray.h"
#include "image/oofimage.h"
#include "common/coord.h"

#ifndef FIX_BORDERS_H
#define FIX_BORDERS_H 

class Fixing {

};

class FixBorders: public Fixing{
	private:
		bool pixelInBounds(ICoord pxl, ICoord size);
		int numPixelsInArea(ICoord center, double curr, DoubleArray gray, DoubleArray &classified, double threshold);
		int numClump;
		int connectNeighbors;
	public:
		FixBorders(int numClump, bool connectNeighbors);
		FixBorders();
		int numSideEmpty(ICoord center, DoubleArray list, int type, int allSides);
		DoubleArray cleanUpSpeckles(DoubleArray gray);	
		void touchBorders(DoubleArray &final, double lowerThreshold);
		DoubleArray connectBorders(DoubleArray gray);
		DoubleArray deleteSmallClumps(DoubleArray gray, int threshold);
		DoubleArray fix(DoubleArray original);
		
};

class NoFix: public Fixing{
	public:
	NoFix();
	DoubleArray fix(DoubleArray a){ return a;};

};



#endif
