// -*- C++ -*-
// $RCSfile: imageops.h,v $
// $Revision: 1.1 $
// $Author: olgak $
// $Date: 2007-07-20 17:50:58 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */


// Basic Image Operations

#include <oofconfig.h>
#include "common/doublearray.h"
#include "image/oofimage.h"

#ifndef IMAGEOPSES_H
#define IMAGEOPSES_H

class DoubleArray;
class BoolArray;
class IntArray;
#include "common/array.h"
class OOFImage;
void setFromArray(OOFImage&,const DoubleArray&); //Creates a color image from an array of doubles
void setFromInt(OOFImage&,const IntArray&);
DoubleArray arrayFromImage(OOFImage&);
static double togray(const CColor &color){ return color.getRed()*.2 + color.getGreen()*.5 + color.getBlue()*.3;};
DoubleArray mountThresholdedImageOnOldImage(DoubleArray gray, DoubleArray newgray);
void drawFixerLines(DoubleArray &gray, int x0, int y0, int x1, int y1, int color);
bool pixelInBounds(ICoord pxl, ICoord size);
DoubleArray normalizeImage(DoubleArray original);
#endif // IMAGEOPS_H
