// -*- C++ -*-
// $RCSfile: thresholding.C,v $
// $Revision: 1.2 $
// $Author: olgak $
// $Date: 2007-07-20 17:50:58 $

/* This software was produced by NIST, an agency of the U.S. government,
* and by statute is not subject to copyright in the United States.
* Recipients of this software assume all responsibilities associated
* with its operation, modification and maintenance. However, to
* facilitate maintenance we ask that before distributing modified
* versions of this software, you first contact the authors at
* oof_manager@ctcms.nist.gov. 
*/ 

#include "image/SEGMENTATION/thresholding.h"

RegularThresholding::RegularThresholding(double th){
	t = th;
}

DoubleArray RegularThresholding::threshold(DoubleArray changed, DoubleArray original){
	DoubleArray final = DoubleArray(changed.size());
	for (DoubleArray::iterator i = original.begin();i !=original.end(); ++i){
		ICoord curr = i.coord();
		double change = original[curr] - changed[curr];
		if (change > t){
			final[curr] = 1;
		}
		if (change < -.01)
			final[curr] = -1;
	}
	return final;
}

DoubleArray RegularThresholding::parse(DoubleArray original){
	DoubleArray final = DoubleArray(original.size());
	for (DoubleArray::iterator i = original.begin();i !=original.end(); ++i){
		ICoord curr = i.coord();
		if (original[curr] >= t)
			final[curr] = 1;
	}
	return final;
}

Canny::Canny(double lower, double upper){
	lowerThreshold = lower;
	upperThreshold = upper;
	
}

DoubleArray Canny::threshold(DoubleArray changed, DoubleArray original){
	CannyClass can = CannyClass(original.size());
	DoubleArray final = can.updateCannyArray(original, lowerThreshold, upperThreshold);
	return final;
}
