# -*- python -*-
# $RCSfile: tests.py,v $
# $Revision: 1.2 $
# $Author: langer $
# $Date: 2007-06-05 15:29:46 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from generics import *

def sensitization0():
    return sensitizationCheck({"Equations:Heat_Eqn active" : 0,
                               "Equations:Plane_Heat_Flux active" : 0,
                               "Equations:Force_Balance active" : 0,
                               "Equations:Plane_Stress active" : 0,
                               "Equations:Coulomb_Eqn active" : 0,
                               "Equations:InPlanePolarization active" : 0,
                               "Copy" : 0},
                              base="OOF2:Equations Page")

def sensitization1():
    return sensitizationCheck({"Equations:Heat_Eqn active" : 1,
                               "Equations:Plane_Heat_Flux active" : 1,
                               "Equations:Force_Balance active" : 1,
                               "Equations:Plane_Stress active" : 1,
                               "Equations:Coulomb_Eqn active" : 1,
                               "Equations:InPlanePolarization active" : 1,
                               "Copy" : 1},
                              base="OOF2:Equations Page")

def buttonCheck(*eqnnames):

    # eqnnames contains the names of the equations that are supposed
    # to be active.  buttonnames is a list of the names of the
    # corresponding buttons, omitting the "OOF2:Equations Page" part
    # of the path.
    buttonnames = ['Equations:%s active' % eqn for eqn in eqnnames]
    # Loop over *all* of the equation buttons.  The first object
    # returned by findAllWidgets is the ScrolledWindow containing the
    # buttons.  The rest of them are buttons.
    widgetpaths = gtklogger.findAllWidgets(
        'OOF2:Equations Page:Equations')
    for buttonpath in widgetpaths[1:]:
        button = gtklogger.findWidget(
            'OOF2:Equations Page:' + buttonpath)
        if button.get_active() ^ (buttonpath in buttonnames):
            print >> sys.stderr, "Button", buttonpath, "is set incorrectly"
            return 0
    return 1


